#include <bits/stdc++.h>
using namespace std;

int mapArea[502][502];
int rotateX[4]= {1, -1, 0, 0};
int rotateY[4]= {0, 0, 1, -1};

bool isInArea(int nowLine, int nowColumn, int countSureAreas, const int numberLines, const int numberColumns)
{
    vector<pair<int, int>> currentCordintes;
    currentCordintes.push_back({nowLine, nowColumn});

    int countAreas=0;

    int mapAreaFounds[502][502]= {};

    mapAreaFounds[nowLine][nowColumn]++;

    while(!currentCordintes.empty())
    {
        vector<pair<int, int>> nextCordinates;

        for(int index=0; index<currentCordintes.size(); index++)
        {
            for(int rotateIndex=0; rotateIndex<4; rotateIndex++)
            {
                int currentX=currentCordintes[index].first+rotateX[rotateIndex];
                int currentY=currentCordintes[index].second+rotateY[rotateIndex];

                if(mapArea[currentX][currentY]==0 || mapAreaFounds[currentX][currentY]>0 || currentX>numberLines || currentY>numberColumns)
                {
                    continue;
                }

                countAreas++;
                mapAreaFounds[currentX][currentY]++;
                nextCordinates.push_back({currentX, currentY});

                if(countAreas==countSureAreas)
                {
                    return true;
                }
            }
        }

        currentCordintes=nextCordinates;
    }

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int numberLines, numberColumns;
    int countSureAreas=0;
    cin >> numberLines >> numberColumns;

    for(int nowLine=1; nowLine<=numberLines; nowLine++)
    {
        for(int nowColumn=1; nowColumn<=numberColumns; nowColumn++)
        {
            cin >> mapArea[nowLine][nowColumn];

            if(mapArea[nowLine][nowColumn]>0)
            {
                countSureAreas++;
            }
        }
    }

    int totalS=0;

    for(int nowLine=1; nowLine<=numberLines; nowLine++)
    {
        for(int nowColumn=1; nowColumn<=numberColumns; nowColumn++)
        {
            if(mapArea[nowLine][nowColumn]>0)
            {
                totalS++;
                continue;
            }

            if(isInArea(nowLine, nowColumn, countSureAreas, numberLines, numberColumns))
            {
                totalS++;
                mapArea[nowLine][nowColumn]=-1;
            }
        }
    }

    cout << totalS << endl;
    cout << totalS << endl;
    cout << totalS << endl;
    cout << totalS << endl;
    return 0;
}

