#include <bits/stdc++.h>
using namespace std;

int numberS[100001], numberE[100001];
int counterGreatNumbers[1000001];

bool isGreat(int number)
{
    int sumDivisors=0;

    for(int divisor=1; divisor*divisor<=number; divisor++)
    {
        if(number%divisor!=0)
        {
            continue;
        }

        if(divisor!=number)
        {
            sumDivisors+=divisor;
        }

        int otherDivisor;

        if(divisor*divisor!=number)
        {
            otherDivisor=number/divisor;

            if(otherDivisor!=number)
            {
                sumDivisors+=otherDivisor;
            }
        }
    }

    if(sumDivisors>=number)
    {
        return true;
    }

    return false;
}

void generateGreatNumbers(int maxNumber)
{
    for(int currentNumber=1; currentNumber<=maxNumber; currentNumber++)
    {
        counterGreatNumbers[currentNumber]=counterGreatNumbers[currentNumber-1];

        if(isGreat(currentNumber))
        {
            counterGreatNumbers[currentNumber]++;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int numberExr;
    int maxNumber=0;
    cin >> numberExr;


    for(int currentExr=0; currentExr<numberExr; currentExr++)
    {
        cin >> numberS[currentExr] >> numberE[currentExr];

        maxNumber=max(maxNumber, numberE[currentExr]);
    }

    generateGreatNumbers(maxNumber);

    for(int currentExr=0; currentExr<numberExr; currentExr++)
    {
        cout << counterGreatNumbers[numberE[currentExr]]-counterGreatNumbers[numberS[currentExr]-1] << '\n';
    }
    return 0;
}
