#include <bits/stdc++.h>
using namespace std;

int counterGreatNumbers[1000001];

bool isGreat(int number)
{
    int sumDivisors=0;

    for(int divisor=1; divisor*divisor<=number; divisor++)
    {
        if(number%divisor!=0)
        {
            continue;
        }

        if(divisor!=number)
        {
            sumDivisors+=divisor;
        }

        int otherDivisor;

        if(divisor*divisor!=number)
        {
            otherDivisor=number/divisor;

            if(otherDivisor!=number)
            {
                sumDivisors+=otherDivisor;
            }
        }
    }

    if(sumDivisors>=number)
    {
        return true;
    }

    return false;
}

void generateGreatNumbers()
{
    for(int currentNumber=1; currentNumber<=1000001; currentNumber++)
    {
        counterGreatNumbers[currentNumber]=counterGreatNumbers[currentNumber-1];

        if(isGreat(currentNumber))
        {
            counterGreatNumbers[currentNumber]++;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int numberExr;
    int maxNumber=0;
    cin >> numberExr;

    generateGreatNumbers();

    for(int currentExr=0; currentExr<numberExr; currentExr++)
    {
        int numberS, numberE;
        cin >> numberS >> numberE;

        cout << counterGreatNumbers[numberE]-counterGreatNumbers[numberS-1] << '\n';
    }
    return 0;
}
