#include<iostream>
using namespace std;
#define ull unsigned long long

int area[502][502];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int a, b;
    cin >> a >> b;
    ull parameter = 0, surface = 0, in_edges = 0, out_edges = 0;

    for (int i = 1; i <= a; i++) {
        for (int j = 1; j <= b; j++) {
            cin >> area[i][j];
            parameter += area[i][j];
            if (area[i][j] != 0) {
                surface++;
            }
        }
    }
    ///Create frame
    for (int i = 0; i <= a; i++) {
        area[i][b + 1] = 0;
        area[i][0] = 0;
    }
    for (int i = 0; i <= b; i++) {
        area[a + 1][i] = 0;
        area[0][i] = 0;
    }


    for (int i = 1; i <= a; i++) {
        for (int j = 1; j <= b; j++) {
            if (area[i + 1][j] != 0 && area[i - 1][j] != 0 && area[i][j + 1] != 0 && area[i][j - 1] != 0) {
                area[i][j] = -1;
                surface++;
            }

            if (area[i][j] == 3) {
                in_edges += 2;
            }
            if (area[i][j] == 2) {
                bool right_zero = false;
                bool left_zero = false;

                if (area[i][j - 1] == 0) {
                    left_zero = true;
                }
                if (area[i][j + 1] == 0) {
                    right_zero = true;
                }
                if (left_zero != right_zero) {
                    in_edges++;
                }
            }
        }
    }
    cout << surface << " " << parameter << " " << in_edges << " " << out_edges;
}
