#include<iostream>
using namespace std;
#define ull unsigned long long

int area[502][502];
int a, b;

/**
5 6
0 0 2 1 2 0
3 2 0 0 1 0
0 0 1 0 1 0
3 2 0 1 0 3
0 0 3 0 3 0
*/
bool enclosed(int y, int x) {
    if (y == a || y == 1 || x == b || x == 1 ) {
        return false;
    }
    area[y][x] = -1;

    if (area[y][x + 1] == 0) {
        if (!enclosed(y, x + 1)) {
            area[y][x] = 0;
            return false;
        }
    }
    if (area[y][x - 1] == 0) {
        if (!enclosed(y, x - 1)) {
            area[y][x] = 0;
            return false;
        }
    }
    if (area[y + 1][x] == 0) {
        if (!enclosed(y + 1, x)) {
            area[y][x] = 0;
            return false;
        }
    }
    if (area[y - 1][x] == 0) {
        if (!enclosed(y - 1, x)) {
            area[y][x] = 0;
            return false;
        }
    }
    return true;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> a >> b;
    ull parameter = 0, surface = 0, in_edges = 0, out_edges = 0;

    for (int i = 1; i <= a; i++) {
        for (int j = 1; j <= b; j++) {
            cin >> area[i][j];
            parameter += area[i][j];
            if (area[i][j] != 0) {
                surface++;
            }
        }
    }
    ///Create frame
    for (int i = 0; i <= a; i++) {
        area[i][b + 1] = 0;
        area[i][0] = 0;
    }
    for (int i = 0; i <= b; i++) {
        area[a + 1][i] = 0;
        area[0][i] = 0;
    }


    for (int i = 1; i <= a; i++) {
        for (int j = 1; j <= b; j++) {
            if (area[i][j] == 0) {
                enclosed(i, j);
            }
            if (area[i][j] == -1) {
                surface++;
            }

            if (area[i][j] == 3) {
                in_edges += 2;
            }
        }
    }

    for (int i = 1; i <= a; i++) {
        for (int j = 1; j <= b; j++) {
            if (area[i][j] == 2) {
                bool right_zero = false;
                bool left_zero = false;

                if (area[i][j - 1] == 0) {
                    left_zero = true;
                }
                if (area[i][j + 1] == 0) {
                    right_zero = true;
                }
                if (left_zero != right_zero) {
                    in_edges++;
                }
            }
        }
    }

    cout << surface << "\n" << parameter << "\n" << in_edges << "\n" << out_edges;
}
